package IM;

import java.lang.*;
import java.io.*;
import java.net.*;

class CA {
    public static void main(String args[]) {
	try {
	    String RLfile = "revocationlist";
	    String CAaddress = "localhost";
	    int CAport;

	    if (args.length > 0) {
		CAport = Integer.parseInt(args[0]);
	    } else {
		FileReader fr = new FileReader("config");
		BufferedReader in = new BufferedReader(fr);
		in.readLine();
		in.readLine();
		CAport = Integer.parseInt(in.readLine());
		in.close();
		fr.close();
	    }

	    ServerSocket srvr = new ServerSocket(CAport);

	    String badwords[] = load_badwords();

	    //You'll need to read "ca.priv"

	    for (;;) {
		Socket skt = srvr.accept();
		System.out.print("[incoming message...]\n");

		ObjectInputStream objin = new ObjectInputStream(skt.getInputStream());

		Squeal sql = (Squeal) objin.readObject();
		objin.close();

		//TODO:
		//1. Read sender's public key (e.g. "alice.pub")
		//2. Decrypt and verify message
		//3. If message is banned then append sender to revocation list
		//   Should check if sender is already on list.
		//   This list must be signed by the CA!

		if (is_banned(sql.message, badwords)) {
		    System.out.print("[banned message detected. updating revocation list...]\n");
		    FileInputStream fis = new FileInputStream("revocationlist");
		    ObjectInputStream ois = new ObjectInputStream(fis);
		    String rl[] = (String[]) ois.readObject();
		    ois.close();
		    fis.close();

		    String newrl[] = new String[rl.length + 1];
		    int i;
		    for (i=0; i<rl.length; i++) newrl[i] = rl[i];
		    newrl[i] = sql.sender;

		    FileOutputStream fos = new FileOutputStream("revocationlist");
		    ObjectOutputStream objout = new ObjectOutputStream(fos);
		    objout.writeObject(newrl);
		    objout.close();
		    fos.close();
		}

		System.out.print("[end of message]\n");
		skt.close();
	    }

	//Note: ideally there should be a more graceful way to stop the server
	//and then we'd call srvr.close();

	}
	catch(Exception e) {
	    System.out.print("Error\n");
	}
    }

    private static String[] load_badwords() {
	try {
	    FileInputStream fis = new FileInputStream("banned");
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    String badwords[] = (String[]) ois.readObject();
	    ois.close();
	    fis.close();
	    return badwords;
	}
	catch(Exception e) {
	    System.out.print("Can't read banned words\n");
	    String empty[] = new String[0];
	    return empty;
	}
    }

    private static boolean is_banned(String message, String badwords[]) {
	int i;
	int n = badwords.length;
	int index;
	for (i=0; i<n; i++) {
	    index = message.indexOf(badwords[i]);
	    if (index >= 0) return true;
	}
	return false;
    }
}
