package IM;

import java.lang.*;
import java.io.*;
import java.net.*;

class Send {
    public static void main(String args[]) {
	try {
	    if (args.length < 3) {
		System.out.println("Usage: send <sender> <receiver> <message>");
		return;
	    }

	    String receiveaddress = "localhost";
	    int receiveport;
	    String CAaddress = "localhost";

	    FileReader fr = new FileReader("config");
	    BufferedReader in = new BufferedReader(fr);
	    in.readLine();
	    receiveport = Integer.parseInt(in.readLine());
	    in.close();
	    fr.close();

	    if (args.length > 3) {
		receiveport = Integer.parseInt(args[3]);
	    }

	    Message msg = new Message();

	    msg.set(args[0], args[1], args[2]);

	    //The sender's private key file is: msg.sender + ".priv"
	    //The receiver's public key file is: msg.receiver + ".pub"

	    //TODO:
	    //1. Read sender's private key (e.g. "alice.priv").
	    //2. Read receiver's public key and certificate (e.g. "bob.pub").
	    //   If the certificate doesn't verify then abort.
	    //3. Verify CA signature on revocation list.
	    //   before testing if receiver is on list.
	    //4. Timestamp, encrypt and sign message.

	    FileInputStream fis = new FileInputStream("revocationlist");
	    ObjectInputStream ois = new ObjectInputStream(fis);
	    String rl[] = (String[]) ois.readObject();
	    ois.close();
	    fis.close();
	    int i;

	    boolean is_revoked = false;

	    for (i=0; i<rl.length; i++) {
		if (rl[i].equals(msg.receiver)) {
		    is_revoked = true;
		    break;
		}
	    }

	    if (!is_revoked) {
		Socket skt = new Socket(receiveaddress, receiveport);
		ObjectOutputStream objout = new ObjectOutputStream(skt.getOutputStream());

		objout.writeObject(msg);
		objout.flush();
		objout.close();
	    } else {
		System.out.println("[not sending, receiver is revoked]");
	    }
	}
	catch(Exception e) {
	     System.out.print("Error\n");
	}
    }
}
